### TIME Elements For Maps ###
import arcview, arcpy, os, shutil, ftplib, datetime, time, traceback, urllib2, subprocess
from time import gmtime, strftime 
from datetime import datetime, timedelta
import wssi_config as cfg
from dateutil import tz
import datetime as DT
from pytz import timezone
from_zone = tz.tzutc()
to_zone = tz.tzlocal()
utc_datetime = datetime.utcnow().strftime("%Y-%m-%d-%H%MZ")
utc1 = datetime.utcnow().strftime("%m/%d/%Y %H:%M")
utc = datetime.strptime(str(utc1), '%m/%d/%Y %H:%M')
utc = utc.replace(tzinfo=from_zone)
Valid = utc.astimezone(to_zone)
valid_tz = Valid.strftime("%m/%d/%Y %H:%M")

#workdir = 'c:/Users/joshua.kastman/degrib/data/wsii/working/'
home_dir = cfg.wssi_dir
datadir = home_dir+"\\data\\grb\\"
refdir = home_dir+"\\data\\reference\\"
workdir = home_dir+"\\data\\working\\"
new_gb_dir = home_dir+"\\data\\ground_blizzard\\"


#datadir = 'C://Users//joshua.kastman//degrib//data//wsii//'
#workdir = 'C://Users//joshua.kastman//degrib//data//wsii//working//'
#---------------------------------------------------------------------------------#
# Snow is representative for six hour block so we will base time off of snow file #
#---------------------------------------------------------------------------------#
file = datadir + "snow.txt"
data = open(file, 'r')
headerline = data.readline()
headerline = headerline.strip()
lines = str(data.read()).splitlines()
msg1 = lines[0]
line = msg1.split(',')
# Establish reference and valid times for first block of snow #
refTimeStr = line[5]
valTimeStrB1 = line[6] 
print "start of forecast, AKA reference time is:"+refTimeStr+" UTC"
print "Valid time for the first forecast block is:"+valTimeStrB1+" UTC"
# convert to datetime object #
refTime = datetime.strptime(str(refTimeStr), ' %m/%d/%Y %H:%M')
refTime = str(refTime)
valTimeB1 = datetime.strptime(str(valTimeStrB1), ' %m/%d/%Y %H:%M')
valTimeB1 = str(valTimeB1)
# Convert UTC to ET
Initial_timeUTC = datetime.strptime(str(refTime), '%Y-%m-%d %H:%M:%S')
Initial_timeTZ = Initial_timeUTC.replace(tzinfo=from_zone)
Initial_timeET = Initial_timeTZ.astimezone(to_zone)
Initial_timeET = Initial_timeET.strftime("%a, %b %d, %Y %I %p")
print "Forecast Begins at: "+Initial_timeET
# Create Valid Times for Day 1 and Day 2 based block 1 end time #
Block_1_EndTime = datetime.strptime(str(valTimeB1), '%Y-%m-%d %H:%M:%S')
Block_1_6HR_CycStartTime = Block_1_EndTime + timedelta(hours=-6)
Block_1_6HR_CycStartTimeTZ = Block_1_6HR_CycStartTime.replace(tzinfo=from_zone)
Block_1_6HR_CycStartTimeET = Block_1_6HR_CycStartTimeTZ.astimezone(to_zone)
Block_1_6HR_CycStartTimeET = Block_1_6HR_CycStartTimeET.strftime("%a, %b %d, %Y %I %p")
print "Block 1 six hour cycle starts at: "+Block_1_6HR_CycStartTimeET
Day1_EndTimeUTC = Block_1_6HR_CycStartTime + timedelta(hours=24)
Day2_EndTimeUTC = Block_1_6HR_CycStartTime + timedelta(hours=48)
print "Day1 End Time: "+str(Day1_EndTimeUTC)
print "Day2 End Time: "+str(Day2_EndTimeUTC)
Day1_EndTimeTZ = Day1_EndTimeUTC.replace(tzinfo=from_zone)
Day1_EndTimeET = Day1_EndTimeTZ.astimezone(to_zone)
Day1_EndTimeET = Day1_EndTimeET.strftime("%a, %b %d, %Y %I %p")
print Day1_EndTimeET
Day2_EndTimeTZ = Day2_EndTimeUTC.replace(tzinfo=from_zone)
Day2_EndTimeET = Day2_EndTimeTZ.astimezone(to_zone)
Day2_EndTimeET = Day2_EndTimeET.strftime("%a, %b %d, %Y %I %p")
print Day2_EndTimeET

###### Time Check ###
from datetime import datetime
currenthour = datetime.utcnow().strftime("%H")
timecheck = float(currenthour)
if timecheck >=0 and timecheck < 6:
    print "Day 3 is a 72 HR Forecast"
    Day3 = 24
elif timecheck >=6 and timecheck < 12:
    print "Day 3 is a 66 HR Forecast"
    Day3 = 18
elif timecheck >=12 and timecheck < 18:
    print "Day 3 is a 60 HR Forecast"
    Day3 = 12
else:
    print "Day 3 is a 54 HR Forecast"
    Day3 = 6
    
if Day3 == 24:
    Day3_EndTimeUTC = Block_1_6HR_CycStartTime + timedelta(hours=72)
elif Day3 == 18:
    Day3_EndTimeUTC = Block_1_6HR_CycStartTime + timedelta(hours=66)
elif Day3 == 12:
    Day3_EndTimeUTC = Block_1_6HR_CycStartTime + timedelta(hours=60)
else:
    Day3_EndTimeUTC = Block_1_6HR_CycStartTime + timedelta(hours=54)

print Day3_EndTimeUTC
Day3_EndTimeTZ = Day3_EndTimeUTC.replace(tzinfo=from_zone)
Day3_EndTimeET = Day3_EndTimeTZ.astimezone(to_zone)
Day3_EndTimeET = Day3_EndTimeET.strftime("%a, %b %d, %Y %I %p")


vtr_d1 = Initial_timeET+" - "+Day1_EndTimeET
vtr_d2 = Day1_EndTimeET+" - "+Day2_EndTimeET
vtr_d3 = Day2_EndTimeET+" - "+Day3_EndTimeET
vtr_f = Initial_timeET+" - "+Day3_EndTimeET

run_hr = datetime.utcnow().strftime("%H")

print vtr_d1
print vtr_d2
print vtr_d3
print vtr_f
print run_hr



f = open(workdir+"time_vars.txt", "w")
f.write(Initial_timeET + "\n" + Day1_EndTimeET + "\n" + Day2_EndTimeET + "\n" + Day3_EndTimeET + "\n"+  run_hr + "\n")
f.close()



# Date / Time formatted for GIS #
GIS_Initial_timeUTC = Initial_timeUTC.strftime("%HZ %m/%d/%y")
GIS_Day1_EndTime = Day1_EndTimeUTC.strftime("%HZ %m/%d/%y")
GIS_Day2_EndTime = Day2_EndTimeUTC.strftime("%HZ %m/%d/%y")
GIS_Day3_EndTime = Day3_EndTimeUTC.strftime("%HZ %m/%d/%y")
GIS_vtr_d1 = GIS_Initial_timeUTC+" - "+GIS_Day1_EndTime
GIS_vtr_d2 = GIS_Day1_EndTime+" - "+GIS_Day2_EndTime
GIS_vtr_d3 = GIS_Day2_EndTime+" - "+GIS_Day3_EndTime
GIS_vtr_f = GIS_Initial_timeUTC+" - "+GIS_Day3_EndTime
print GIS_vtr_d1
print GIS_vtr_d2
print GIS_vtr_d3
print GIS_vtr_f

f = open(workdir+"gis_time_vars.txt", "w")
f.write(GIS_Initial_timeUTC + "\n" + GIS_Day1_EndTime + "\n" + GIS_Day2_EndTime + "\n" + GIS_Day3_EndTime + "\n")
f.close()

def time_stamps(**kwargs):
    from datetime import datetime, timedelta
    for key, value in kwargs.items():
        #workdir = 'c:/Users/joshua.kastman/degrib/data/wsii/working/'
        #datadir = 'C://Users//joshua.kastman//degrib//data//wsii//'
        #workdir = 'C://Users//joshua.kastman//degrib//data//wsii//working//'

        #f1 = open(datadir+"snow.txt", "r")
        file = datadir + "snow.txt"
        data = open(file, 'r')
        headerline = data.readline()
        headerline = headerline.strip()
        lines = str(data.read()).splitlines()
        msg1 = lines[0]
        line = msg1.split(',')
        t1_it = line[5]
        t1_vt = line[6]
        print t1_vt

        ##
        i_evt = datetime.strptime(str(t1_vt), ' %m/%d/%Y %H:%M')
        i_evt = str(i_evt)

        Initial_time = datetime.strptime(str(i_evt), '%Y-%m-%d %H:%M:%S')
        d1_ivt = Initial_time + timedelta(hours=-6)
        d1_ivt2 = d1_ivt.replace(tzinfo=from_zone)
        d1_ivt3 = d1_ivt2.astimezone(value[0])
        d1_ilt = d1_ivt3.strftime("%a, %b %d, %Y %I %p")
        print d1_ilt
        
        i_it = datetime.strptime(str(t1_it), ' %m/%d/%Y %H:%M')
        i_it = str(i_it)
        Initial_Itime = datetime.strptime(str(i_it), '%Y-%m-%d %H:%M:%S')
        #d1_ivt = Initial_time + timedelta(hours=-6)
        Initial_ItimeTZPRE = Initial_Itime.replace(tzinfo=from_zone)
        Initial_ItimeTZ = Initial_ItimeTZPRE.astimezone(value[0])
        Initial_ItimeFinal = Initial_ItimeTZ.strftime("%a, %b %d, %Y %I %p")
        print Initial_ItimeFinal

        
        d1_et = d1_ivt + timedelta(hours=24)
        d2_et = d1_ivt + timedelta(hours=48)
        #print d1_et
        #print d2_et
        d1_et2 = d1_et.replace(tzinfo=from_zone)
        d1_et3 = d1_et2.astimezone(value[0])
        d1_lt = d1_et3.strftime("%a, %b %d, %Y %I %p")
        print d1_lt
        d2_et2 = d2_et.replace(tzinfo=from_zone)
        d2_et3 = d2_et2.astimezone(value[0])
        d2_lt = d2_et3.strftime("%a, %b %d, %Y %I %p")
        print d2_lt

        ###### Time Check ###
        ##
        from datetime import datetime
        currenthour = datetime.utcnow().strftime("%H")
        timecheck = float(currenthour)
        if timecheck >=0 and timecheck < 6:
            print "Day 3 is a 72 HR Forecast"
            Day3 = 24
        elif timecheck >=6 and timecheck < 12:
            print "Day 3 is a 66 HR Forecast"
            Day3 = 18
        elif timecheck >=12 and timecheck < 18:
            print "Day 3 is a 60 HR Forecast"
            Day3 = 12
        else:
            print "Day 3 is a 54 HR Forecast"
            Day3 = 6


        if Day3 == 24:
            d3_et = d1_ivt + timedelta(hours=72)
        elif Day3 == 18:
            d3_et = d1_ivt + timedelta(hours=66)
        elif Day3 == 12:
            d3_et = d1_ivt + timedelta(hours=60)
        else:
            d3_et = d1_ivt + timedelta(hours=54)

        print d3_et
        d3_et2 = d3_et.replace(tzinfo=from_zone)
        d3_et3 = d3_et2.astimezone(value[0])
        d3_lt = d3_et3.strftime("%a, %b %d, %Y %I %p")

        vtr_d1 = Initial_ItimeFinal+" - "+d1_lt
        vtr_d2 = d1_lt+" - "+d2_lt
        vtr_d3 = d2_lt+" - "+d3_lt
        vtr_f = Initial_ItimeFinal+" - "+d3_lt


        print vtr_d1
        print vtr_d2
        print vtr_d3
        print vtr_f



        f = open(workdir+"time_vars_"+value[1]+".txt", "w")
        f.write(Initial_ItimeFinal + "\n" + d1_lt + "\n" + d2_lt + "\n" + d3_lt + "\n")
        f.close()

#---------------------------------------#
# Establish timezones for static images #
#---------------------------------------#

Eastern = timezone('America/New_York')
Central = timezone('America/Chicago')
Mountain = timezone('America/Denver')
Western = timezone('America/Los_Angeles')
# Eastern #
to_zone_e = Eastern
valid_east = utc.astimezone(to_zone_e)
valid_east_tz = valid_east.strftime("%m/%d/%Y %H:%M")
# Central #
to_zone_c = Central
valid_cent = utc.astimezone(to_zone_c)
valid_cent_tz = valid_cent.strftime("%m/%d/%Y %H:%M")
# Mountain #
to_zone_m = Mountain
valid_mount = utc.astimezone(to_zone_m)
valid_mount_tz = valid_mount.strftime("%m/%d/%Y %H:%M")
# Western #
to_zone_w = Western
valid_west = utc.astimezone(to_zone_w)
valid_west_tz = valid_west.strftime("%m/%d/%Y %H:%M")

print valid_east_tz
print valid_cent_tz
print valid_mount_tz
print valid_west_tz


time_stamps(east = [to_zone_e, "East"], cent = [to_zone_c, "Central"], mount = [to_zone_m, "Mountain"], west = [to_zone_w, "West"])

