# -*- coding: utf-8 -*-
#------------------------------------------------#
# Filename: wssi_config.py                       #
# Description: WSSI Configuration File           #
# Author: Josh Kastman -- WPC                    #
# Contact: joshua.kastman@noaa.gov               # 
# Change Log:                                    #
# Script Created -- 06/21/2021 -- Kastman -- WPC #
#------------------------------------------------#

#imports
#from datetime import datetime, timedelta

#--------------#
# Global Paths #
#--------------#
wssi_dir = "O:\\wssi\\operational"
data_dir = wssi_dir+"\\data"
scripts = wssi_dir+"\\scripts\\"
img_dir = wssi_dir+"\\images"
mxd_dir = wssi_dir+"\\mxds\\"
grb_dir = data_dir+"\\grb\\"
log_dir = data_dir+"\\logs\\"
log_archive = log_dir+"log_archive\\"
ref_dir = data_dir+"\\reference\\"
gb_dir = data_dir+"\\ground_blizzard\\"
gb_wrk_dir = data_dir+"\\ground_blizzard\\working\\"
sn_climo = data_dir+"\\snow_climo\\"
work_dir = data_dir+"\\working\\"
ff_wrk_dir = wssi_dir+"\\working\\ff_working\\"
geog_dir = data_dir+"\\geography"
comp_out = img_dir+"\\components_output\\"
roll_out = img_dir+"\\rolling_output\\"
static = img_dir+"\\static\\"
web_imgs = img_dir+"\\web_map_images\\"
xmls= img_dir+"\\xmls\\"
degribdir = 'O:/ndfd/degrib/bin/'
dev_data = "O:\\wssi\\operational\\data\\grb\\" # temporary 
in_mem = "in_memory/"
#-------------------------------#
# Constants and reference files #
#-------------------------------#
plink="C:\Program Files\PuTTY\plink.exe"
pscp="C:\Program Files\PuTTY\pscp.exe"
key = "C:\\Users\\joshua.kastman\\gis\\keys\\kastman_wpc_vs_wpcgsops_private.ppk"
evergreen = ref_dir+"evergreen_2pt5.tif"
rate_factor = ref_dir+ "rate_factor"
States = geog_dir+"\\WSSI.gdb\\States"
wssi_2dsn_avg = wssi_dir+"\\data\\snow_climo\\avg_2day_mpm_30yr_qc_mtn_adj_2pt5.tif"
wssi_2dsn_std = wssi_dir+"\\data\\snow_climo\\std_2day_mpm_30yr_qc_mtn_adj_2pt5.tif"
urbanfactor = ref_dir+"urbanfactor.tif"
landuse = ref_dir+"landuse_bs.tif"
#-----------------------------#
# Remote Server Paths & Files #
#-----------------------------#
linux_user = "hpcops"
linux_cpu = "vm-lnx-wpccf1:"
lxn_ndfd = "/data/model/grid/grib/ndfd/"

#----------------------#
# Lists & Dictionaries #
#----------------------#

grid_list = ['wpc_d4qpf','temp','wgust','qpf','iceaccum','snow','wgust_d4','wpc_d4snow']#,'temp_d4',     'temp','wgust','qpf','iceaccum','snow','temp_d4','wgust_d4']
#precip_num_list = []
#precip_hrs = []
precip_num_list_d4 = [1,2,3,4]
precip_d4_hrs = ["78","84","90","96"]
wgust_num_list = []
wgust_hrs = []
wgust_dict = {}
d4wgust_dict = {}
d4wgust_final = {}
fcst_hr_list = ["6","12","18","24","30","36","42","48","54","60","66","72","78","84","90","96"]
monthDict= {1:'January', 2:'February', 3:'March', 4:'April', 5:'May', 6:'June', 7:'July', 8:'August', 9:'September', 10:'October', 11:'November', 12:'December'}
rdict = {'1':'6','2':'12','3':'18','4':'24','5':'30','6':'36','7':'42','8':'48','9':'54','10':'60','11':'66','12':'72'}
rdict_d4 = {'1':'78','2':'84','3':'90','4':'96'}

