import arcpy, os, shutil, ftplib, datetime, time, traceback, urllib2, subprocess
from datetime import datetime
from time import gmtime, strftime, strptime
import logging
import traceback
import sys
import fnmatch
from datetime import datetime
from time import gmtime, strftime, strptime
from datetime import timedelta
import tarfile
from pytz import timezone
#from_zone = tz.tzutc()
#to_zone = tz.tzlocal()
from time import mktime

home_dir = os.getcwd()
gis_dir = home_dir+"\\gis\\"
gis_wdir = home_dir+"\\gis\\working\\"
base_wdir = home_dir+"\\data\\working\\"
log_dir =  home_dir+"\\data\\logs\\"
comp_dir = home_dir+"\\images\\components_output\\"

in_mem = "in_memory/"
mxd_dir = home_dir+"\\mxds\\"
arcpy.ImportToolbox("O:/zip-shapefiles-master/Toolbox.tbx")
arcpy.gp.toolbox = "O:/zip-shapefiles-master/Toolbox.tbx";

#base_wdir = "C:\\Users\\joshua.kastman\\degrib\\data\\wsii\\working\\"
#gis_wdir = "C:\\Users\\joshua.kastman\\gis\\wsii\\operational\\gis\\working\\"


import logging
# set up log file
log_stamp = strftime("%Y%m%d%H", gmtime())
logging.basicConfig(filename=log_dir+'/wssi_log_'+str(log_stamp)+'_SHP_GEN.log',level=logging.DEBUG, format='%(asctime)s %(message)s', datefmt='%m/%d/%Y %I:%M:%S %p')

#from time import gmtime, strftime

start_time = strftime("%a, %d %b %Y %H:%M:%S", gmtime())

print "WSSI GIS Processing Start Time "+start_time


def clean():
    print ("Cleaning out old files")
    logging.debug('Cleaning out old files')
    try:
        for root, dirs, files in os.walk(gis_wdir):
            for f in files:
                os.unlink(os.path.join(root, f))
            for d in dirs:
                shutil.rmtree(os.path.join(root, d))
    except Exception as e:
        print(traceback.format_exc())
        logging.error(traceback.format_exc())
        
###################
# End of Function #
###################
#clean()


##wssi_tifs_all = ['finalicemax.tif|Days_1_3','total_snamt_I.tif|Days_1_3','total_cum_max.tif|Days_1_3','ff_max.tif|Days_1_3','WSII_GB_FINAL.tif|Days_1_3','full_snowload_re.tif|Days_1_3','WSII_SnowLoad.tif|Days_1_3','wsii_total.tif|Days_1_3',
##                  'finalicemax_v24.tif|Day_1','v24hrsnamt_I.tif|Day_1','v24hr_cum_max.tif|Day_1','ff_max_24hr.tif|Day_1','WSII_GB_FINAL24hr.tif|Day_1','v24hr_snowload_re.tif|Day_1','WSII_24_SnLd.tif|Day_1','wsii_f24.tif|Day_1',
##                  'finalicemax_v48.tif|Day_2','v48hrsnamt_I.tif|Day_2','v48hr_cum_max.tif|Day_2','WSII_GB_FINAL48hr.tif|Day_2','v48hr_snowload_re.tif|Day_2','WSII_48_SnLd.tif|Day_2','wsii_f48.tif|Day_2',
##                  'finalicemax_d3.tif|Day_3','d3_hrsnamt_I.tif|Day_3','d3_cum_max.tif|Day_3','d3_snowload_re.tif|Day_3','WSII_d3_SnLd.tif|Day_3','wsii_f_d3.tif|Day_3']
##
##wssi_tifs_full = ['finalicemax.tif','total_snamt_I.tif','total_cum_max.tif','ff_max.tif','WSII_GB_FINAL.tif','WSII_SnowLoad.tif','wsii_total.tif'] # 'WSII_SnowLoad.tif','full_snowload_re.tif'
##wssi_tifs_d1 = ['finalicemax_v24.tif','v24hrsnamt_I.tif','v24hr_cum_max.tif','ff_max_24hr.tif','WSII_GB_FINAL24hr.tif','WSSI_24_SnLd.tif','wsii_f24.tif'] # 'WSII_24_SnLd.tif', 'v24hr_snowload_re.tif'
##wssi_tifs_d2 = ['finalicemax_v48.tif','v48hrsnamt_I.tif','v48hr_cum_max.tif','WSII_GB_FINAL48hr.tif','WSSI_48_SnLd.tif','wsii_f48.tif'] #'WSII_48_SnLd.tif',v48hr_snowload_re.tif'
##wssi_tifs_d3 = ['finalicemax_d3.tif','d3_hrsnamt_I.tif','d3_hr_cum_max.tif','WSSI_d3_SnLd.tif','wsii_f_d3.tif'] # 'WSII_d3_SnLd.tif''d3_snowload_re.tif'

##for t in wssi_tifs_all:
##    f = open(gis_wdir+"tiff_list.txt", "a")
##    f.write(str(t)+ "\n")
##    f.close()

 
thresh = [0.9,2.9,4.9,6.9,8.9]
impacts = ["LIMITED","MINOR","MODERATE","MAJOR","EXTREME"]
periods = ["Days_1_3","Day_1","Day_2","Day_3",]

pdct = "PRODUCT"
prod = "WINTER STORM SEVERITY INDEX"
comp = "COMPONENT"
imp = "IMPACT"
validT = "VALID_TIME"
issueT = "ISSUE_TIME"
startT = "START_TIME"
endT = "END_TIME" 

#kwarg_dict ={"Days_1-3": wssi_tifs_full, periods[1]: wssi_tifs_d1,periods[2]: wssi_tifs_d2, periods[3]: wssi_tifs_d3}
#print kwarg_dict

#-
# Time Variables
#-
workdir = base_wdir
f = open(workdir+"gis_time_vars.txt", "r")
lines = f.readlines()
d1_it = lines[0][:-1]
d1_et = lines[1][:-1]
d2_et = lines[2][:-1]
d3_et = lines[3][:-1]
f.close()

it = datetime.utcnow().strftime("%Y-%m-%d %H%MZ")
#it = datetime.utcnow().strftime("%Y-%m %H:%M")
#print it
#sys.exit()
from arcpy.sa import *
arcpy.CheckOutExtension('Spatial')
arcpy.env.overwriteOutput = True

b = sys.argv[1:]
data = str(b[0])
print data
###logging.debug("File to Process: " +data)

#data = 'gb_fp.tif'
fname = data[:-4]
data_list = fname.split("_")
print data_list
value = data_list[-1]
print value
wssi_tifs = data
print wssi_tifs

#sys.exit()

def wssi_proc():
#def wssi_proc(**kwargs):
    #--------------------------------------------#
    # Convert raster to polygon for each isohyet # 
    #--------------------------------------------#
    print "Convert raster to polygon for each isohyet"
    #logging.debug ('Convert raster to polygon for each isohyet')
    #for f in fcst_hr:
    #for value:
    #print (key)
    print (value)
    global wssi_dict
    #global wssi_tifs
    
    if value == "fp":
        #wssi_tifs = wssi_tifs_full
        wssi_dict = {"ice_fp": "ICE_ACCUMULATION","snow_fp": "SNOW_AMOUNT","bl_sn_fp": "BLOWING_SNOW","ff_fp": "FLASH_FREEZE","gb_fp": "GROUND_BLIZZARD",
                     "sn_ld_win_fp": "SNOW_LOAD","wssi_overall_fp": "WSSI_OVERALL"}
        vp = str(d1_it)+" - "+str(d3_et)
        st = str(d1_it)
        et = str(d3_et)
    elif value == "d1":
        #wssi_tifs = wssi_tifs_d1
        wssi_dict = {"ice_d1": "ICE_ACCUMULATION","snow_d1": "SNOW_AMOUNT","bl_sn_d1" : "BLOWING_SNOW","ff_d1": "FLASH_FREEZE","gb_d1": "GROUND_BLIZZARD",
                     "sn_ld_win_d1": "SNOW_LOAD","wssi_overall_d1": "WSSI_OVERALL"}
        vp = str(d1_it)+" - "+str(d1_et)
        st = str(d1_it)
        et = str(d1_et)
    elif value == "d2":
        #wssi_tifs = wssi_tifs_d2
        wssi_dict = {"ice_d2": "ICE_ACCUMULATION","snow_d2": "SNOW_AMOUNT","bl_sn_d2" : "BLOWING_SNOW","gb_d2": "GROUND_BLIZZARD",
                     "sn_ld_win_d2": "SNOW_LOAD","wssi_overall_d2": "WSSI_OVERALL"}
        vp = str(d1_et)+" - "+str(d2_et)
        st = str(d1_et)
        et = str(d2_et)
    elif value == "d3":
        #wssi_tifs = wssi_tifs_d3
        wssi_dict = {"ice_d3": "ICE_ACCUMULATION","snow_d3": "SNOW_AMOUNT","bl_sn_d3" : "BLOWING_SNOW",
                     "sn_ld_win_d3": "SNOW_LOAD","wssi_overall_d3": "WSSI_OVERALL"}
        vp = str(d2_et)+" - "+str(d3_et)
        st = str(d2_et)
        et = str(d3_et)
    else:
        print "value error"
    value_dict = {"fp":"Days_1_3","d1":"Day_1","d2":"Day_2","d3":"Day_3"}

    print wssi_tifs[:-4]
    print "THIS IS THE VALUE FOR wssi_tifs "+wssi_tifs
    try:
        file_list = []
        for i,m in zip(thresh,impacts):
            
##            #print ('contouring fcst_hr '+ str(c)+' ; ' +str(i)+' threshold')
            arcpy.Resample_management(comp_dir+wssi_tifs, in_mem+fname+'_BIL_'+m, "5000 5000", "BILINEAR")
            arcpy.gp.Contour_sa(in_mem+fname+'_BIL_'+m, in_mem+fname+'_'+m, "100", i, "1", "CONTOUR_POLYGON", "")
            print in_mem+fname+'_'+m+'.shp'
            with arcpy.da.UpdateCursor(in_mem+fname+'_'+m, 'ContourMin') as cursor:
                for row in cursor:
                    if row[0] == 0:
                        cursor.deleteRow()
                    else:
                        pass
            arcpy.SimplifyPolygon_cartography(in_mem+fname+'_'+m, in_mem+fname+'_'+m+'_'+value+'_final_poly', "POINT_REMOVE", "1000 Meters", "30 SquareKilometers", "RESOLVE_ERRORS", "NO_KEEP", "")
            arcpy.Delete_management(in_mem+fname+'_'+m)

            arcpy.AddField_management(in_mem+fname+'_'+m+'_'+value+'_final_poly', pdct, "TEXT", "", "", "40", "", "NULLABLE", "NON_REQUIRED", "")
            arcpy.CalculateField_management(in_mem+fname+'_'+m+'_'+value+'_final_poly', pdct, "\""+prod+"\"", "PYTHON", "")
            arcpy.AddField_management(in_mem+fname+'_'+m+'_'+value+'_final_poly', validT, "TEXT", "", "", "30", "", "NULLABLE", "NON_REQUIRED", "")
            arcpy.CalculateField_management(in_mem+fname+'_'+m+'_'+value+'_final_poly', validT, "\""+vp+"\"", "PYTHON", "")
            arcpy.AddField_management(in_mem+fname+'_'+m+'_'+value+'_final_poly', comp, "TEXT", "", "", "20", "", "NULLABLE", "NON_REQUIRED", "")
            arcpy.CalculateField_management(in_mem+fname+'_'+m+'_'+value+'_final_poly', comp, "\""+wssi_dict[fname]+"\"", "PYTHON", "")
            arcpy.AddField_management(in_mem+fname+'_'+m+'_'+value+'_final_poly', imp, "TEXT", "", "", "30", "", "NULLABLE", "NON_REQUIRED", "")
            arcpy.CalculateField_management(in_mem+fname+'_'+m+'_'+value+'_final_poly', imp, "\""+m+"\"", "PYTHON", "")
            arcpy.AddField_management(in_mem+fname+'_'+m+'_'+value+'_final_poly', issueT, "TEXT", "", "", "30", "", "NULLABLE", "NON_REQUIRED", "")
            arcpy.CalculateField_management(in_mem+fname+'_'+m+'_'+value+'_final_poly', issueT, "\""+it+"\"", "PYTHON", "")
            arcpy.AddField_management(in_mem+fname+'_'+m+'_'+value+'_final_poly', startT, "TEXT", "", "", "30", "", "NULLABLE", "NON_REQUIRED", "")
            arcpy.CalculateField_management(in_mem+fname+'_'+m+'_'+value+'_final_poly', startT, "\""+st+"\"", "PYTHON", "")
            arcpy.AddField_management(in_mem+fname+'_'+m+'_'+value+'_final_poly', endT, "TEXT", "", "", "30", "", "NULLABLE", "NON_REQUIRED", "")
            arcpy.CalculateField_management(in_mem+fname+'_'+m+'_'+value+'_final_poly', endT, "\""+et+"\"", "PYTHON", "")
            #arcpy.AddField_management(gis_wdir+c[:-4]+'_'+m+'_'+value+'_final_poly.shp', "Thresh", "FLOAT", "4", "2", "", "", "NULLABLE", "NON_REQUIRED", "")
            #arcpy.CalculateField_management(gis_wdir+c[:-4]+'_'+m+'_'+value+'_final_poly.shp', "Thresh", float(i), "PYTHON", "")
            
            file_list.append(in_mem+fname+'_'+m+'_'+value+'_final_poly')
        merge = ";".join(file_list)
        arcpy.Merge_management(merge, gis_wdir+wssi_dict[fname]+'_'+value_dict[value]+'.shp', "")
        arcpy.Delete_management(in_mem+fname+'_'+m+'_'+value+'_final_poly')

    except:
        print(traceback.format_exc())
        pass


    global final_file
    final_file = gis_wdir+wssi_dict[fname]+'_'+value_dict[value]+'.shp'
    print final_file
    print ('merging hourly file contours into a final file. File: ' +final_file+' completed') 
    #arcpy.Merge_management(merge, final_file, "")
    #arcpy.SimplifyPolygon_cartography(gis_wdir+wssi_dict[fname]+'_'+value+'_pre.shp', gis_wdir+wssi_dict[fname]+'_'+value+'.shp', "POINT_REMOVE", "1000 Meters", "30 SquareKilometers", "RESOLVE_ERRORS", "NO_KEEP", "")

    try:
        rcount = int(arcpy.GetCount_management(final_file).getOutput(0))
        if(rcount == 0):
            print final_file+ " is blank, passing"
            logging.debug(final_file+ " is blank, passing")
            pass
        else: 
            arcpy.DeleteField_management(final_file, "ContourMin;ContourMax;InPoly_FID;SimPgnFlag;MaxSimpTol;MinSimpTol")
            print final_file+ " uneeded fields cleared"
            #merge_list.append(gis_wdir+wssi_dict[c[:-4]]+'_'+value+'.shp')
    except:
        "ERRO IN DELETE FIELD"

    # Process: Zip Shapefile
    print ("Zipping shapefiles")
    logging.debug("Zipping shapefiles")
    arcpy.ImportToolbox("O:/zip-shapefiles-master/Toolbox.tbx")
    arcpy.gp.toolbox = "O:/zip-shapefiles-master/Toolbox.tbx";


    try:
        arcpy.gp.ZipShapefile(final_file, gis_wdir+wssi_dict[fname]+'_'+value_dict[value]+"_latest.zip", "w")
    except:
       print(traceback.format_exc())

###################
# End of Function #
###################

##def wssi_kmls():
##    #mxd_dir = "C:\\Users\\joshua.kastman\\gis\\wsii\\operational\\mxds\\"
##    print mxd_dir+"wssi_kmls.mxd"
##    mxd=arcpy.mapping.MapDocument(mxd_dir+"wssi_kmls.mxd")
##    print "kml still working"
##
##    global lyr
##    for lyr in arcpy.mapping.ListLayers(mxd):
##        try:
##            print "Layer = "+lyr.name
##            #lyr.transparency = 40
##            arcpy.LayerToKML_conversion(lyr,gis_wdir+lyr.name+"_latest.kmz",1)
##            print "Generated: "+lyr.name+"_latest.kmz"
##        except Exception as e:
##            print e.message, e.args


###################
# End of Function #
###################
           

##def tar_zip():
##
##    #-----------------------------------------------------#
##    # Create tar files                                    #
##    # Only tar: .dbf, .prj, .shp, .shx                    #
##    #-----------------------------------------------------#
##    
##    os.chdir(gis_wdir)
##    #global tar_name
##    #tar_file = tarfile.open(final_file+'_latest.tar', "w")
##
##    
##    #for name in [final_file+'.dbf', final_file+'.prj', final_file+'.shp', final_file+'.shx']:
##    #    tar_file.add(name)
##    #tar_file.close()
##
##    #global tar
##    #tar = final_file+'_latest.tar'
##    #---------------#
##    # Zip shp files #
##    #---------------#
##    
##    # Process: Zip Shapefile
##    print ("Zipping shapefiles")
##    logging.debug("Zipping shapefiles")
##    #arcpy.ImportToolbox("C:/Users/joshua.kastman/Documents/ArcGIS/zip-shapefiles-master/zip-shapefiles-master/Toolbox.tbx")
##    #arcpy.gp.toolbox = "C:/Users/joshua.kastman/Documents/ArcGIS/zip-shapefiles-master/zip-shapefiles-master/Toolbox.tbx";
##
##
##        
##    #EXCESSIVERAIN_DAYx_latest_new.zip
##    #final_file = gis_wdir+wssi_dict[c[:-4]]+'_'+value+'.shp'
##    #print "merge list: "+ final_file
##    for p in periods:
##        for c in wssi_tifs:
##            final_file = gis_wdir+wssi_dict[c[:-4]]+'_'+p+'.shp'
##            print "final_file: "+final_file
##                
##            #arcpy.gp.ZipShapefile(final_file, final_file+"_latest.zip", "w")

###################
# End of Function #
###################

##def send_files():
##    # Send files to the World Wide Web
##    linux_user = "hpc"
##    linux_cpu = "hpcrzdm:"
##    #pwd = "4Mouse!Sticky@feet"
##    #pwd = "2LemonPollywogs!"
##    pwd = "Rotten_Peaches4U"
##
##    gis_wdir = "C:\\Users\\joshua.kastman\\gis\\wsii\\operational\\gis\\working"
##    shp_dir = "//home/www//hpc//htdocs//wwd//wssi//gis//shp//"
##    kmz_dir = "//home/www//hpc//htdocs//wwd//wssi//gis//kmz//"
##
##    #tar_name = 'QPF168hr_Day1-7'
##    #tar_dir = 'https://ftp.wpc.ncep.noaa.gov/shapefiles/qpf/7day/'
##
##    # kml target directory
##    #target_dir = tar_dir
##
##    pscp="C:\Program Files\PuTTY\pscp.exe"
##
##    kmz_file = "C:\\Users\\joshua.kastman\\gis\\wsii\\operational\\gis\\working\\*.kmz"
##    shp_file = "C:\\Users\\joshua.kastman\\gis\\wsii\\operational\\gis\\working\\*.zip"
##    
##    print "Publishing shp and kmz to web"
##    logging.debug("Publishing shp and kmz to web")
##    try:
##        print (pscp+" -pw "+pwd+" "+shp_file+" "+linux_user+"@"+linux_cpu+shp_dir)
##        subprocess.call(pscp+" -pw "+pwd+" "+kmz_file+" "+linux_user+"@"+linux_cpu+kmz_dir)
##        subprocess.call(pscp+" -pw "+pwd+" "+shp_file+" "+linux_user+"@"+linux_cpu+shp_dir)
##    except:
##        print ("Trouble sending files to web")
##        print(traceback.format_exc())
##        logging.debug("Trouble sending files to web")



###################
# End of Function #
###################


#-------------------#
# Execute Functions #
#-------------------# 
wssi_proc()
#wssi_proc(f="Days_1_3",d1="Day_1",d2="Day_2",d3="Day_3")
#wssi_kmls()
#send_files()
####tar_zip()

arcpy.CheckInExtension('Spatial')
finish_time = strftime("%a, %d %b %Y %H:%M:%S", gmtime())
print "WSSI GIS Processing Start Time "+start_time
print "WSSI GIS Processing Script Finished "+finish_time
logging.debug ("WSSI GIS Processing Start Time "+start_time)
logging.debug ("WSSI GIS Processing Script Finished "+finish_time)
logging.shutdown()
