# -*- coding: utf-8 -*-
# WSSI KML Generator
# Author: Joshua Kastman
import arcpy, os, shutil, ftplib, datetime, time, traceback, urllib2, subprocess
from datetime import datetime
from time import gmtime, strftime, strptime
import logging
import traceback
import sys
import fnmatch
from datetime import datetime
from time import gmtime, strftime, strptime
from datetime import timedelta
import tarfile
from pytz import timezone
#from_zone = tz.tzutc()
#to_zone = tz.tzlocal()
from time import mktime

home_dir = os.getcwd()
gis_dir = home_dir+"\\gis\\"
gis_wdir = home_dir+"\\gis\\working\\"
base_wdir = home_dir+"\\data\\working\\"
log_dir =  home_dir+"\\data\\logs\\"
comp_dir = home_dir+"\\images\\components_output\\"
key = "C:\\Users\\joshua.kastman\\gis\\keys\\kastman_wpc_vs_wpcgsops_private.ppk"

in_mem = "in_memory/"
mxd_dir = home_dir+"\\mxds\\"
arcpy.ImportToolbox("O:/zip-shapefiles-master/Toolbox.tbx")
arcpy.gp.toolbox = "O:/zip-shapefiles-master/Toolbox.tbx";

start_time = strftime("%a, %d %b %Y %H:%M:%S", gmtime())
print "WSSI GIS Processing Start Time "+start_time

# set up log file
log_stamp = strftime("%Y%m%d%H", gmtime())
logging.basicConfig(filename=log_dir+'/wssi_log_'+str(log_stamp)+'_GIS_SEND.log',level=logging.DEBUG, format='%(asctime)s %(message)s', datefmt='%m/%d/%Y %I:%M:%S %p')


def wssi_kmls():
    #mxd_dir = "C:\\Users\\joshua.kastman\\gis\\wsii\\operational\\mxds\\"
    print mxd_dir+"wssi_kmls.mxd"
    mxd=arcpy.mapping.MapDocument(mxd_dir+"wssi_kmls.mxd")
    print "kml still working"

    global lyr
    for lyr in arcpy.mapping.ListLayers(mxd):
        try:
            print "Layer = "+lyr.name
            #lyr.transparency = 40
            arcpy.LayerToKML_conversion(lyr,gis_wdir+lyr.name+"_latest.kmz",1)
            logging.debug("Generated: "+lyr.name+"_latest.kmz")
            print "Generated: "+lyr.name+"_latest.kmz"
        except Exception as e:
            print e.message, e.args


###################
# End of Function #
###################

def send_files():
    # Send files to the World Wide Web
    linux_user = "hpc"
    linux_cpu = "hpcrzdm:"
    #pwd = "4Mouse!Sticky@feet"
    #pwd = "2LemonPollywogs!"
    pwd = "Rotten_Peaches4U"

    #gis_wdir = "C:\\Users\\joshua.kastman\\gis\\wsii\\operational\\gis\\working"
    shp_dir = "//home/www//hpc//htdocs//wwd//wssi//gis//shp//"
    kmz_dir = "//home/www//hpc//htdocs//wwd//wssi//gis//kmz//"

    #tar_name = 'QPF168hr_Day1-7'
    #tar_dir = 'https://ftp.wpc.ncep.noaa.gov/shapefiles/qpf/7day/'

    # kml target directory
    #target_dir = tar_dir

    pscp="C:\Program Files\PuTTY\pscp.exe"

    kmz_file = gis_wdir+"*.kmz"
    shp_file = gis_wdir+"*.zip"
    
    print "Publishing shp and kmz to web"
    logging.debug("Publishing shp and kmz to web")
    try:
        #print (pscp+" -pw "+pwd+" "+shp_file+" "+linux_user+"@"+linux_cpu+shp_dir)
        subprocess.call(pscp+" -i "+key+" "+kmz_file+" "+linux_user+"@"+linux_cpu+kmz_dir)
        subprocess.call(pscp+" -i "+key+" "+shp_file+" "+linux_user+"@"+linux_cpu+shp_dir)
        #aws
        subprocess.call('aws s3 cp O:\wssi\operational\gis\working s3://s3-east-www.wpc.woc.noaa.gov/public/wwd/wssi/gis/shp/ --recursive --exclude "*" --include "*.zip"')
        subprocess.call('aws s3 cp O:\wssi\operational\gis\working s3://s3-east-www.wpc.woc.noaa.gov/public/wwd/wssi/gis/kmz/ --recursive --exclude "*" --include "*.kmz"')
    except:
        print ("Trouble sending files to web")
        print(traceback.format_exc())
        logging.debug("Trouble sending files to web")



###################
# End of Function #
###################          

#-------------------#
# Execute Functions #
#-------------------# 
wssi_kmls()
send_files()

arcpy.CheckInExtension('Spatial')
finish_time = strftime("%a, %d %b %Y %H:%M:%S", gmtime())
print "WSSI GIS Processing Start Time "+start_time
print "WSSI GIS Processing Script Finished "+finish_time
logging.debug ("WSSI KML Processing Start Time "+start_time)
logging.debug ("WSSI KML Processing Script Finished "+finish_time)
logging.shutdown()
sys.exit()
